<?php
declare(strict_types=1);

namespace App\Entity\Message;

use ApiPlatform\Metadata\ApiResource;
use App\Entity\Access\Access;
use App\Entity\Core\Tagg;
//use DH\Auditor\Provider\Doctrine\Auditing\Annotation\Auditable;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use Ramsey\Uuid\Uuid;

/**
 * @todo : A la suite de la migration, il faut supprimer le nom de la table pour avoir une table Sms, et supprimer l'attribut discr.
 * @todo : migration table tag_message
 *
 * Classe ... qui ...
 */
//#[Auditable]
#[ApiResource(operations: [])]
#[ORM\Table(name: 'Message')]
#[ORM\Entity]
class Sms extends AbstractMessage
{
    #[ORM\Column(length: 255, nullable: false)]
    private string $discr = 'sms';

    #[ORM\ManyToOne(inversedBy: 'sms')]
    #[ORM\JoinColumn(nullable: true)]
    private Access $author;

    #[ORM\OneToMany(mappedBy: 'sms', targetEntity: ReportSms::class, cascade: ['persist'], orphanRemoval: true)]
    private Collection $reports;

    #[ORM\ManyToMany(targetEntity: Tagg::class, inversedBy: 'sms', cascade: ['persist'])]
    #[ORM\JoinTable(name: 'tag_message')]
    #[ORM\JoinColumn(name: 'message_id', referencedColumnName: 'id')]
    #[ORM\InverseJoinColumn(name: 'tag_id', referencedColumnName: 'id')]
    protected Collection $tags;

    public function __construct()
    {
        $this->uuid = Uuid::uuid4();
        $this->reports = new ArrayCollection();
        $this->tags = new ArrayCollection();
    }

    public function getDiscr(): ?string
    {
        return $this->discr;
    }

    public function setDiscr(string $discr): self
    {
        $this->discr = $discr;

        return $this;
    }

    public function getAuthor(): ?Access
    {
        return $this->author;
    }

    public function setAuthor(?Access $author): self
    {
        $this->author = $author;

        return $this;
    }

    /**
     * @return Collection<int, ReportSms>
     */
    public function getReports(): Collection
    {
        return $this->reports;
    }

    public function addReport(ReportSms $report): self
    {
        if (!$this->reports->contains($report)) {
            $this->reports[] = $report;
            $report->setSms($this);
        }

        return $this;
    }

    public function removeReport(ReportSms $report): self
    {
        if ($this->reports->removeElement($report)) {
            // set the owning side to null (unless already changed)
            if ($report->getSms() === $this) {
                $report->setSms(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection<int, Tagg>
     */
    public function getTags(): Collection
    {
        return $this->tags;
    }

    public function addTag(Tagg $tag): self
    {
        if (!$this->tags->contains($tag)) {
            $this->tags[] = $tag;
        }

        return $this;
    }

    public function removeTag(Tagg $tag): self
    {
        $this->tags->removeElement($tag);

        return $this;
    }
}
